## com.fasterxml.jackson.databind.ser.std
Class AsArraySerializerBase<T>

    java.lang.Object
      com.fasterxml.jackson.databind.JsonSerializer<T>
          com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
              com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
                  com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase<T>

All Implemented Interfaces:
  SchemaAware, ContextualSerializer

Direct Known Subclasses:
  CollectionSerializer, EnumSetSerializer, IndexedListSerializer, IterableSerializer, IteratorSerializer

    public abstract class AsArraySerializerBase<T>

extends ContainerSerializer<T>
implements ContextualSerializer

Base class for serializers that will output contents as JSON arrays; typically serializers used for `Collection` and array types.

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer
`JsonSerializer.None`

Field Summary
`protected PropertySerializerMap` `_dynamicSerializers` If element type can not be statically determined, mapping from runtime type to serializer is handled using this object
`protected JsonSerializer<Object>` `_elementSerializer` Value serializer to use, if it can be statically determined
`protected JavaType` `_elementType`
`protected BeanProperty` `_property` Collection-valued property being serialized with this instance
`protected boolean` `_staticTyping`
`protected TypeSerializer` `_valueTypeSerializer` Type serializer used for values, if any.

Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer
`_handledType`

Constructor Summary
`protected` `AsArraySerializerBase(AsArraySerializerBase<?> src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer)`
`protected` `AsArraySerializerBase(Class<?> cls, JavaType et, boolean staticTyping, TypeSerializer vts, BeanProperty property, JsonSerializer<Object> elementSerializer)`

Method Summary
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, Class<?> type, SerializerProvider provider)`
`protected JsonSerializer<Object>` `_findAndAddDynamic(PropertySerializerMap map, JavaType type, SerializerProvider provider)`
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`JsonSerializer<?>` `getContentSerializer()` Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
`JavaType` `getContentType()` Accessor for finding declared (static) element type for type this serializer is used for.
`JsonNode` `getSchema(SerializerProvider provider, Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
`void` `serialize(T value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`protected abstract void` `serializeContents(T value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)`
`void` `serializeWithType(T value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`abstract AsArraySerializerBase<T>` `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer)`

Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer
`_withValueTypeSerializer, isEmpty, withValueTypeSerializer`

Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer
`createObjectNode, createSchemaNode, createSchemaNode, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow`

Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer
`isUnwrappingSerializer, unwrappingSerializer, usesObjectId`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### _staticTyping

    protected final boolean _staticTyping

### _elementType

    protected final JavaType _elementType

### _valueTypeSerializer

    protected final TypeSerializer _valueTypeSerializer

  Type serializer used for values, if any.

### _elementSerializer

    protected final JsonSerializer<Object> _elementSerializer

  Value serializer to use, if it can be statically determined

### _property

    protected final BeanProperty _property

  Collection-valued property being serialized with this instance

### _dynamicSerializers

    protected PropertySerializerMap _dynamicSerializers

  If element type can not be statically determined, mapping from runtime type to serializer is handled using this object

Constructor Detail

### AsArraySerializerBase

    protected AsArraySerializerBase(Class<?> cls,
                                    JavaType et,
                                    boolean staticTyping,
                                    TypeSerializer vts,
                                    BeanProperty property,
                                    JsonSerializer<Object> elementSerializer)

### AsArraySerializerBase

    protected AsArraySerializerBase(AsArraySerializerBase<?> src,
                                    BeanProperty property,
                                    TypeSerializer vts,
                                    JsonSerializer<?> elementSerializer)

Method Detail

### withResolved

    public abstract AsArraySerializerBase<T> withResolved(BeanProperty property,
                                                          TypeSerializer vts,
                                                          JsonSerializer<?> elementSerializer)

### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                              BeanProperty property)
                                       throws JsonMappingException

  Description copied from interface: `ContextualSerializer`
  Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

  Specified by:
    `createContextual` in interface `ContextualSerializer`
  Parameters:
    `provider` - Serializer provider to use for accessing config, other serializers
    `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
  Returns:
    Serializer to use for serializing values of specified property; may be this instance or a new instance.
  Throws:
    `JsonMappingException`

### getContentType

    public JavaType getContentType()

  Description copied from class: `ContainerSerializer`
  Accessor for finding declared (static) element type for type this serializer is used for.

  Specified by:
    `getContentType` in class `ContainerSerializer<T>`

### getContentSerializer

    public JsonSerializer<?> getContentSerializer()

  Description copied from class: `ContainerSerializer`
  Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.

  Specified by:
    `getContentSerializer` in class `ContainerSerializer<T>`

### serialize

    public final void serialize(T value,
                                com.fasterxml.jackson.core.JsonGenerator jgen,
                                SerializerProvider provider)
                         throws IOException,
                                com.fasterxml.jackson.core.JsonGenerationException

  Description copied from class: `JsonSerializer`
  Method that can be called to ask implementation to serialize values of type this serializer handles.

  Specified by:
    `serialize` in class `StdSerializer<T>`
  Parameters:
    `value` - Value to serialize; can not be null.
    `jgen` - Generator used to output resulting Json content
    `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### serializeWithType

    public final void serializeWithType(T value,
                                        com.fasterxml.jackson.core.JsonGenerator jgen,
                                        SerializerProvider provider,
                                        TypeSerializer typeSer)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonGenerationException

  Description copied from class: `JsonSerializer`
  Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

  Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

  For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

        // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
        typeSer.writeTypePrefixForScalar(value, jgen);
        serialize(value, jgen, provider);
        typeSer.writeTypeSuffixForScalar(value, jgen);

  and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY>/`END-ARRAY` and `START-OBJECT>/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.

  ``
  Overrides:
    `serializeWithType` in class `JsonSerializer<T>`
  Parameters:
    `value` - Value to serialize; can not be null.
    `jgen` - Generator used to output resulting Json content
    `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
    `typeSer` - Type serializer to use for including type information
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### serializeContents

    protected abstract void serializeContents(T value,
                                              com.fasterxml.jackson.core.JsonGenerator jgen,
                                              SerializerProvider provider)
                                       throws IOException,
                                              com.fasterxml.jackson.core.JsonGenerationException

  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonGenerationException`

### getSchema

    public JsonNode getSchema(SerializerProvider provider,
                              Type typeHint)
                       throws JsonMappingException

  Description copied from class: `StdSerializer`
  Default implementation simply claims type is "string"; usually overriden by custom serializers.

  Specified by:
    `getSchema` in interface `SchemaAware`
  Overrides:
    `getSchema` in class `StdSerializer<T>`
  Parameters:
    `provider` - The serializer provider.
    `typeHint` - A hint about the type.
  Returns:
    Json-schema for this serializer.
  Throws:
    `JsonMappingException`

### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                              Class<?> type,
                                                              SerializerProvider provider)
                                                       throws JsonMappingException

  Throws:
    `JsonMappingException`

### _findAndAddDynamic

    protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                              JavaType type,
                                                              SerializerProvider provider)
                                                       throws JsonMappingException

  Throws:
    `JsonMappingException`

Copyright © 2012 fasterxml.com. All Rights Reserved.